/**
 * DateWidget module.
 * @module
 */
define(['template-controller', 'text!date/template.html', 'css!date/widget'], // template and css
    function(TemplateController, template) {
        var templateController = new TemplateController('widget-date', template);

        /**
         * Class DateWidget constructor. Method render is mandatory for any widget.
         * @class
         * @param attrs, widget level attributes, specifically, attrs.id should be the exactly same as the attribute id of that widget DOM
         * @return the concrete widget class
         */
        return function(attrs) {
            /**
             * Render the widget.
             * @param data, attrs will be merged into data and sent to template controller to finalize the rendering
             */
            this.render = function(data) {
                templateController.render(attrs, data);
            };
        };
    }
);